package video.pano.pano_rtc

import android.content.Context
import android.os.Handler
import android.os.Looper
import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.EventChannel
import io.flutter.plugin.common.MethodChannel

/** PanoRtcPlugin */
class PanoRtcPlugin : FlutterPlugin {
    /// The MethodChannel that will the communication between Flutter and native Android
    ///
    /// This local reference serves to register the plugin with the Flutter Engine and unregister it
    /// when the Flutter Engine is detached from the Activity
    companion object {
        lateinit var binding: FlutterPlugin.FlutterPluginBinding
        lateinit var context: Context
        lateinit var engineManager: RtcEngineManager

        fun createMethodChannel(name: String): MethodChannel {
            return MethodChannel(binding.binaryMessenger, name)
        }

        fun createEventChannel(name: String): EventChannel {
            return EventChannel(binding.binaryMessenger, name)
        }
    }

    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        binding = flutterPluginBinding
        context = flutterPluginBinding.applicationContext
        flutterPluginBinding.platformViewRegistry.registerViewFactory("PanoNativeView",
                PanoNativeViewFactory())
        engineManager = RtcEngineManager()
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        engineManager.onDetachedFromEngine()
    }
}


