package video.pano.pano_rtc

import com.pano.rtc.api.RtcNetworkManager
import video.pano.pano_rtc.api.IRtcNetworkManager

class RtcNetworkManager (private val manager: RtcNetworkManager?) : FlutterWrapper(),
        IRtcNetworkManager, RtcNetworkManager.Callback {

    init {
        methodChannel = PanoRtcPlugin.createMethodChannel("pano_rtc/api_networkMgr")
        eventChannel = PanoRtcPlugin.createEventChannel("pano_rtc/events_networkMgr")
        methodChannel.setMethodCallHandler(this)
        eventChannel?.setStreamHandler(this)
    }

    private fun callback(methodName: String, vararg data: Any?) {
        emit(methodName, hashMapOf("data" to data.toList()))
    }

    override fun startNetworkTest(params: Map<String, *>, callback: Callback) {
        val token = params["token"] as String
        callback.success(manager?.startNetworkTest(token, this))
    }

    override fun stopNetworkTest(params: Map<String, *>, callback: Callback) {
        callback.success(manager?.stopNetworkTest())
    }

    override fun onNetworkTestComplete(quality: RtcNetworkManager.NetworkQuality?) {
        val map = mapOf(
                "rating" to quality?.rating?.value,
                "txLoss" to quality?.txLoss,
                "rxLoss" to quality?.rxLoss,
                "rtt" to quality?.rtt
        )
        callback("onNetworkTestComplete", map)
    }
}