package video.pano.pano_rtc.events

import com.pano.rtc.api.Constants
import com.pano.rtc.api.PanoAnnotation

class RtcAnnotationEvent (
        private val emit: (methodName: String, data: Map<String, Any?>?) -> Unit
) : PanoAnnotation.Callback {

    private fun callback(methodName: String, vararg data: Any?) {
        emit(methodName, hashMapOf("data" to data.toList()))
    }

    override fun onSnapshotComplete(result: Constants.QResult?, filename: String?) {
        callback("onSnapshotComplete", result?.value, filename)
    }

    override fun onAnnoRoleChanged(newRole: Constants.WBRoleType?) {
        callback("onAnnoRoleChanged", newRole?.value)
    }
}