package video.pano.pano_rtc.events

import com.pano.rtc.api.PanoAnnotationManager

class RtcAnnotationManagerEvent(
        private val emit: (methodName: String, data: Map<String, Any?>?) -> Unit
) : PanoAnnotationManager.Callback {

    private fun callback(methodName: String, vararg data: Any?) {
        emit(methodName, hashMapOf("data" to data.toList()))
    }

    override fun onShareAnnotationStart(userId: Long) {
        callback("onShareAnnotationStart", userId)
    }

    override fun onVideoAnnotationStart(userId: Long, streamId: Int) {
        callback("onVideoAnnotationStart", userId, streamId)
    }

    override fun onShareAnnotationStop(userId: Long) {
        callback("onShareAnnotationStop", userId)
    }

    override fun onVideoAnnotationStop(userId: Long, streamId: Int) {
        callback("onVideoAnnotationStop", userId, streamId)
    }
}